/*
 * Copyright (c) 1983 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
/*+:EDITS:*/
/*:05-08-1990-15:29-wht@n4hgf-rawthru */
/*:05-08-1990-15:28-wht@n4hgf-mv tipout.c tipout-orig.c */

#ifndef lint
static char sccsid[] = "@(#)tipout.c	5.2 (Berkeley) 9/2/88";
#endif /* not lint */

#include "tip.h"
/*
 * tip
 *
 * lower fork of tip -- handles passive side
 *  reading from the remote host
 */

static	jmp_buf sigbuf;

#ifdef BSCRIPT
int bsdesc[2];
#endif
/*
 * TIPOUT wait state routine --
 *   sent by TIPIN when it wants to posses the remote host
 */
sigfunc_t
intIOT()
{

	write(repdes[1],&ccc,1);
	read(fildes[0], &ccc,1);
	longjmp(sigbuf, 1);
}

/*
 * Scripting command interpreter --
 *  accepts script file name over the pipe and acts accordingly
 */
sigfunc_t
intEMT()
{
	char c, line[256];
	register char *pline = line;
	char reply;

	read(fildes[0], &c, 1);
	while (c != '\n') {
		*pline++ = c;
		read(fildes[0], &c, 1);
	}
	*pline = '\0';
	if (boolean(value(SCRIPT)) && fscript != NULL)
		fclose(fscript);
	if (pline == line) {
		boolean(value(SCRIPT)) = FALSE;
		reply = 'y';
	} else {
		if ((fscript = fopen(line, "a")) == NULL)
			reply = 'n';
		else {
			reply = 'y';
			boolean(value(SCRIPT)) = TRUE;
#ifdef BSCRIPT
			if (!pipe(bsdesc)) {
				FILE *fp;

				switch (fork()) {
				case -1:
					close(bsdesc[0]);
					close(bsdesc[1]);
					break;
				case 0:
					close(bsdesc[1]);
					longjmp(sigbuf, 2);
					break;
				default:
					close(bsdesc[0]);
					if ((fp = fdopen(bsdesc[1], "w")) == NULL)
						close(bsdesc[1]);
					else {
						fclose(fscript);
						fscript = fp;
					}
					break;
				}
			}
#endif
		}
	}
	write(repdes[1], &reply, 1);
	longjmp(sigbuf, 1);
}

sigfunc_t
intTERM()
{

	if (boolean(value(SCRIPT)) && fscript != NULL)
		fclose(fscript);
	finish();
}

sigfunc_t
intSYS()
{

	boolean(value(BEAUTIFY)) = !boolean(value(BEAUTIFY));
	longjmp(sigbuf, 1);
}

#ifdef TIPX
extern int rawthru;
sigfunc_t
int_tipout_rawthru_on()
{
	rawthru = 1;
}
sigfunc_t
int_tipout_rawthru_off()
{
	rawthru = 0;
}
#endif /* TIPX */

#ifdef JTIPX
extern int japmode,emacsmode;
#endif
/*
 * ****TIPOUT   TIPOUT****
 */
tipout()
{
	char buf[BUFSIZ];
	register char *cp;
	register int cnt;
	extern int errno;
	int omask;

	signal(SIGINT, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGEMT, intEMT);		/* attention from TIPIN */
	signal(SIGTERM, intTERM);	/* time to go signal */
	signal(SIGIOT, intIOT);		/* scripting going on signal */
	signal(SIGHUP, intTERM);	/* for dial-ups */
	signal(SIGSYS, intSYS);		/* beautify toggle */
#ifdef TIPX
	signal(SIGUSR1, int_tipout_rawthru_on);
	signal(SIGUSR2, int_tipout_rawthru_off);
#endif /* TIPX */
#ifdef BSCRIPT
	switch (setjmp(sigbuf)) {
	case 2:
		signal(SIGEMT, SIG_IGN);
		signal(SIGTERM, SIG_IGN);
		signal(SIGIOT, SIG_IGN);
		signal(SIGHUP, SIG_IGN);
		signal(SIGSYS, SIG_IGN);
		signal(SIGUSR1, SIG_IGN);
		signal(SIGUSR2, SIG_IGN);
		while ((cnt = read(bsdesc[0], buf, BUFSIZ)) > 0)
			for (cp = buf; cp < buf + cnt; ++cp)
				putc(*cp, fscript);
		fclose(fscript);
		close(bsdesc[0]);
		exit(0);
		break;
	}
#else
	(void) setjmp(sigbuf);
#endif
	for (omask = 0;; sigsetmask(omask)) {
		cnt = read(FD, buf, BUFSIZ);
		if (cnt <= 0) {
			/* lost carrier */
			if (cnt < 0 && errno == EIO) {
				sigblock(sigmask(SIGTERM));
				intTERM();
				/*NOTREACHED*/
			}
			continue;
		}
#ifdef TIPX
#define	ALLSIGS	sigmask(SIGEMT)|sigmask(SIGTERM)|sigmask(SIGIOT)|sigmask(SIGSYS)|sigmask(SIGUSR1)|sigmask(SIGUSR2)
#else /* TIPX */
#define	ALLSIGS	sigmask(SIGEMT)|sigmask(SIGTERM)|sigmask(SIGIOT)|sigmask(SIGSYS)
#endif /* TIPX */
		omask = sigblock(ALLSIGS);
#ifdef TIPX
#ifdef JTIPX
		if(!japmode && !rawthru)
#else
		if(!rawthru)
#endif
#endif
		for (cp = buf; cp < buf + cnt; cp++)
			*cp &= 0177;
#ifdef JTIPX
		if(emacsmode) {
			register char *bcp;
			for (bcp = cp = buf; cp < buf + cnt; cp++)
				if (*cp == '\r') {
					if (cp > bcp)
						write(1, bcp, cp - bcp);
					bcp = cp + 1;
				}
			if (cp > bcp)
				write(1, bcp, cp - bcp);
		} else
#endif
		write(1, buf, cnt);
		if (boolean(value(SCRIPT)) && fscript != NULL) {
			if (!boolean(value(BEAUTIFY))) {
				fwrite(buf, 1, cnt, fscript);
				continue;
			}
#ifdef TIPX
#ifdef JTIPX
			if(!japmode && rawthru)
#else
			if(rawthru)
#endif
				for (cp = buf; cp < buf + cnt; cp++)
					*cp &= 0177;
#endif /* TIPX */
			for (cp = buf; cp < buf + cnt; cp++)
				if ((*cp >= ' ' && *cp <= '~') ||
#ifdef JTIPX
				    (japmode && (0377&*cp) >= 0200) ||
#endif
				    any(*cp, value(EXCEPTIONS)))
					putc(*cp, fscript);
		}
	}
}
